ifndef CXX 
	@echo "Please set the environment for C++ Compiler"
	exit(1)
endif

# C++ Flags
CXX_FLAGS_OMPC = -fopenmp -fopenmp-targets=x86_64-pc-linux-gnu -fno-openmp-new-driver
CXX_FLAGS_ALVEO = -fopenmp -fopenmp-targets=alveo -fno-openmp-new-driver

# Path Location
INC_FLAGS = -I./
LIB_FLAGS = 

# Libs inclusion
LIBS = 

# Targets
TARGETS = vadd vadd-fpga

all: $(TARGETS)

.PRECIOUS: %.cpp

vadd: vadd.cpp
	@echo "Building OMPC example"
	$(CXX) $^ $(CXX_FLAGS_OMPC) $(INC_FLAGS) $(LIB_FLAGS) -o $@ $(LIBS)

vadd-fpga: vadd.cpp
	@echo "Building OMPC+FPGA example"
	$(CXX) $^ $(CXX_FLAGS_ALVEO) $(INC_FLAGS) $(LIB_FLAGS) -o $@ $(LIBS)

test_ompc_tiny: vadd
	OMPCLUSTER_DISABLE_FPGA=1 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 960 6

test_ompc_small: vadd
	OMPCLUSTER_DISABLE_FPGA=1 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 1048512 6

test_ompc_medium: vadd
	OMPCLUSTER_DISABLE_FPGA=1 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 16777152 6

test_ompc_large: vadd
	OMPCLUSTER_DISABLE_FPGA=1 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 268435392 6

test_fpga_tiny: vadd-fpga
	OMPTARGET_ALVEO_BOARDS_NODE=2 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 960 6
	
test_fpga_small: vadd-fpga
	OMPTARGET_ALVEO_BOARDS_NODE=2 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 1048512 6

test_fpga_medium: vadd-fpga
	OMPTARGET_ALVEO_BOARDS_NODE=2 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 16777152 6

test_fpga_large: vadd-fpga
	OMPTARGET_ALVEO_BOARDS_NODE=2 mpirun -np 7 -f /mirror/sdumont/config/hosts ./$^ 268435392 6

clean:
	rm -f $(TARGETS)

.PHONY: all clean

